<?php
if(!defined('WPINC')) exit('Do NOT access this file directly: '. basename(__FILE__)); // MUST have WordPress.
if (!defined('CCA_MAXMIND_DATA_DIR')) define('CCA_MAXMIND_DATA_DIR', "ccaMaxDataDir-Replace");
if (!defined('CCA_MAX_FILENAME')) define('CCA_MAX_FILENAME', 'GeoData-Replace');

function cca_qc_plugin() {
  if (empty($GLOBALS['comet_cache_advanced_cache'])) return;
  $ac = $GLOBALS['comet_cache_advanced_cache'];
  $ac->addFilter('comet_cache_version_salt', 'cca_qc_salt_shaker');
}

cca_qc_plugin(); // Run this plugin.


function cca_qc_salt_shaker($version_salt) { // Salt shaker.
  $cczc_maxmindDirectory = "cczcMaxDir-Replace"; // location of Maxmind script, this string is replaced/generated by the plugin 
	$just_these = array();  // the list of country codes to be separately cached, this string is replaced/generated by the plugin 
	$my_ccgroup = array();  // the list of country codes to cached as a group

  // return info requested by Country Caching plugin
  if ($version_salt == 'cca_version') return 'unknown version';  // replaced by version when addon built
	if ($version_salt == 'cca_options') return implode("," , $just_these);
	if ($version_salt == 'cca_group') return implode("," , $my_ccgroup);
	if ($version_salt == 'cca_data') return CCA_MAXMIND_DATA_DIR;

// return original or modified key to Comet/Zen/QC

  // makes cookie notice work with Comet Cache
  if (isset($_COOKIE['cookie_notice_accepted']) ) :
      if ( $_COOKIE['cookie_notice_accepted'] == 'true'):
          $version_salt = $version_salt . 'CNt';
      else:
        $version_salt = $version_salt . 'CNf';
      endif;
  endif;

  if ( isset($GLOBALS['CCA_ISO_CODE']) && $GLOBALS['CCA_ISO_CODE'] == '') return $version_salt;
  if ( ! isset($GLOBALS['CCA_ISO_CODE']) || ! ctype_alnum($GLOBALS['CCA_ISO_CODE']) || ! strlen($GLOBALS['CCA_ISO_CODE']) == 2 ) {   // : cczc_lookupISO($cczc_maxmindDirectory);
    $GLOBALS['CCA_ISO_CODE'] = '';
    if (! function_exists('cca_run_geo_lookup') ) include $cczc_maxmindDirectory . 'cca_lookup_ISO.inc';
    if (function_exists('cca_run_geo_lookup') ) cca_run_geo_lookup($cczc_maxmindDirectory);
    if ($GLOBALS['CCA_ISO_CODE'] == '') return $version_salt;
  }

  //  if both "just_these" and "my_ccgroup" are empty we want to separately cache every country; also separately cache if country is in just_these
  if ( (empty($just_these) && empty($my_ccgroup) ) || in_array($GLOBALS['CCA_ISO_CODE'], $just_these) ) return $version_salt . $GLOBALS['CCA_ISO_CODE'];
  // if country is not specified for sep caching ($just_these, above) but is part of group that should be cached together
  if ( ! empty($my_ccgroup) && in_array($GLOBALS['CCA_ISO_CODE'], $my_ccgroup) ) return $version_salt . 'mygroup';
  if ( empty($just_these)) return $version_salt . $GLOBALS['CCA_ISO_CODE']; // this visitor country is not in the ccgroup entry so separately cache
  
  return $version_salt;  # visitor country and is not one of "just these" or group so use default cache
}
